#include <assert.h>
#include "cpl_string.h"

typedef struct
{
    const char* testString;
    CPLValueType expectedResult;
} TestStringStruct;

int main(int argc, char* argv[])
{
    TestStringStruct apszTestStrings[] =
    {
        { "+25.e+3", CPL_VALUE_REAL },
        { "-25.e-3", CPL_VALUE_REAL },
        { "25.e3", CPL_VALUE_REAL },
        { "25e3", CPL_VALUE_REAL },
        { " 25e3 ", CPL_VALUE_REAL },

        { "25", CPL_VALUE_INTEGER },
        { "-25", CPL_VALUE_INTEGER },
        { "+25", CPL_VALUE_INTEGER },

        { "25e 3", CPL_VALUE_STRING },
        { "25e.3", CPL_VALUE_STRING },
        { "-2-5e3", CPL_VALUE_STRING },
        { "2-5e3", CPL_VALUE_STRING },
        { "25.25.3", CPL_VALUE_STRING },
        { "25e25e3", CPL_VALUE_STRING },
    };

    int i;
    for(i=0;i < sizeof(apszTestStrings) / sizeof(apszTestStrings[0]); i++)
    {
        if (CPLGetValueType(apszTestStrings[i].testString) != apszTestStrings[i].expectedResult)
            fprintf(stderr, "mismatch on item %d : \"%s\", %d, %d\n", i, apszTestStrings[i].testString, 
                    apszTestStrings[i].expectedResult, CPLGetValueType(apszTestStrings[i].testString));
    }

    return 0;
}
